/* (c) Beer/Won-wan    2003.4.15 */
#ifndef	_BEWITCH_H_
#define	_BEWITCH_H_

//#include	<stdio.h>
//#include	<kernel/OS.h>
#include	<Be.h>
#include	<math.h>
#include	"swan.h"

class BW_con_view:public BView
{
	public:
		BW_con_view(BRect frame,char *title);
		void	AttachedToWindow();
		void	Draw(BRect rect);
//		void	Pulse();
//		void	MouseDown(BPoint pt);
		void	MessageReceived(BMessage *mes);
//	private:
		BSlider	*bw_vb_sl;
		BRadioButton	*bw_mc_rb[8];
		BCheckBox	*bw_pr_cb[2];
};

class BW_chr_view:public BView
{
	public:
		BW_chr_view(BRect frame,char *title);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
//		void	MouseDown(BPoint pt);
	private:
		BBitmap	*bm;
		char	viewf;	// 0.512chrs 1.1024chrs
};

class BW_pal_view:public BView
{
	public:
		BW_pal_view(BRect frame,char *title);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
//		void	MouseDown(BPoint pt);
	private:
		BBitmap	*bm;
};

class BW_scr_view:public BView
{
	public:
		BW_scr_view(BRect frame,char *title,int no);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
//		void	MouseDown(BPoint pt);
	private:
		BBitmap	*bm;
		int		sn;		// 0.sprite  1.screen1  2.screen2
};

class BW_lcd_view:public BView
{
	public:
		BW_lcd_view(BRect frame,char *title);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
//		void	MouseDown(BPoint pt);
	private:
		BBitmap	*bm,*tbm,*ybm,*vbm;
		char	viewf;	// b1.yoko/tate  b2.old/color
};

class BW_seg_view:public BView
{
	public:
		BW_seg_view(BRect frame,char *title);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
	private:
		BBitmap	*bm,*tbm,*vbm;
		char	viewf;	// b1.yoko/tate  b2.old/color
};

class BW_con_win:public BWindow
{
	public:
		BW_con_win(BRect frame,char *title);
		bool	QuitRequested();
		void	Zoom(BPoint rec_position,float rec_width,float rec_height);
//	private:
		BW_con_view	*bw_v;
};

class BW_chr_win:public BWindow
{
	public:
		BW_chr_win(BRect frame,char *title);
		bool	QuitRequested();
		void	changemode();
	private:
		BW_chr_view	*bw_cv;
		char	winf;	// 0.512chrs 1.1024chrs
};

class BW_pal_win:public BWindow
{
	public:
		BW_pal_win(BRect frame,char *title);
		bool	QuitRequested();
	private:
		BW_pal_view	*bw_pv;
};

class BW_scr_win:public BWindow
{
	public:
		BW_scr_win(BRect frame,char *title,int no);
		bool	QuitRequested();
	private:
		BW_scr_view	*bw_sv;
		int		sn;		// 0.sprite  2.screen1  2.screen2
};

class BW_lcd_win:public BWindow
{
	public:
		BW_lcd_win(BRect frame,char *title);
		bool	QuitRequested();
		void	changemode();
	private:
		BW_lcd_view	*bw_lv;
		BW_seg_view	*bw_segv;
		char	winf;	// b1.yoko/tate  b2.old/color
};

class BW_app:public BApplication
{
	public:
		BW_app(void);
		bool	QuitRequested();
		void	MessageReceived(BMessage *mes);
		BW_con_win	*bw_w;
		BW_chr_win	*bw_cw;
		BW_pal_win	*bw_pw;
		BW_scr_win	*bw_s0w,*bw_s1w,*bw_s2w;
		BW_lcd_win	*bw_lw;
	private:
		thread_id	bw_vb_id;
		thread_id	bw_snd_id;
		thread_id	bw_com_id;
};

int		main();
int32	vblank(void* data);
int32	sound(void* data);
int32	comm(void* data);

uchar	mode;	// b0.normal/reverse  b1.yoko/tate  b2.gray/color
uchar	slp;	// sleeping flag  b0.vblank(main)  b1.sound  b2.comm
BBitmap	*bw_sbm[3];
int		bw_vb_t=13000;	//for VBLANK(13.333msec)

uint16	segpat[]={											//gray
	0x0000,0x0600,0x0602,0x0e07,0x0f0c,0xff00,0xffff,0x7ff3,	//sleep
	0x3fc0,0x1f80,0x3fc0,0x3fc0,0x79c0,0x60e0,0x0060,0x0000,
	0x0000,0x0000,0x3000,0x3400,0x0600,0x0330,0x3e78,0x3efc,	//vertical
	0x3efc,0x3e78,0x0330,0x0600,0x3400,0x3000,0x0000,0x0000,
	0x0000,0x0000,0x0180,0x03c0,0x07e0,0x07e0,0x03c0,0x0180,	//horizontal
	0x0420,0x0ff0,0x1bd8,0x03c0,0x33cc,0x33cc,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0180,0x03c0,	//aux1
	0x03c0,0x0180,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x03c0,0x07e0,0x0ff0,0x0ff0,	//aux2
	0x0ff0,0x0ff0,0x07e0,0x03c0,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x03c0,0x0ff0,0x1ff8,0x1ff8,0x3ffc,0x3ffc,	//aux3
	0x3ffc,0x3ffc,0x1ff8,0x1ff8,0x0ff0,0x03c0,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x03c0,0x07e0,0x0660,0x0c30,0x0c30,0x0e70,	//power
	0x0ff0,0x0ff0,0x0ff0,0x07e0,0x07e0,0x03c0,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x7ffe,0x4002,0x4002,0x4002,0x4002,	//cartridge
	0x4002,0x7ffe,0x7ffe,0x7ffe,0x7ffe,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0xfffc,0x8004,0xa007,0xb001,	//battery
	0xb801,0xbc07,0x8004,0xfffc,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x000c,0x0206,0x0706,0x0f43,0xdf23,0xdf33,	//volume
	0xdf33,0xdf23,0x0f43,0x0706,0x0206,0x000c,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0ff0,0x3ffc,0x781e,0xc003,0x9819,	//headphone
	0xb81d,0xb81d,0x381c,0x1818,0x0000,0x0000,0x0000,0x0000,
															//color
	0x0000,0x0000,0x1800,0x1980,0x0980,0x31c0,0x7bfc,0x07fc,	//sleep
	0x0ff8,0x07f0,0x03f8,0x03fc,0x038c,0x0300,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0180,0x03c0,0x07e0,0x07e0,0x03c0,	//vertical
	0x03c0,0x07e0,0x0ff0,0x1bd8,0x33cc,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0008,0x0018,0x0030,0x0660,0x0ff8,0x1ff8,	//horizontal
	0x1ff8,0x0ff8,0x0660,0x0030,0x0018,0x0008,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0180,	//aux1
	0x0180,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0180,0x03c0,	//aux2
	0x03c0,0x0180,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x03c0,0x07e0,0x0ff0,0x0ff0,	//aux3
	0x0ff0,0x0ff0,0x07e0,0x03c0,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,	//
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0180,0x07e0,0x09f0,	//power
	0x09f0,0x07e0,0x0180,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0fe0,0x08e0,0x08e0,0x08e0,	//cartridge
	0x08e0,0x08e0,0x08e0,0x0fe0,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x1ffe,0x7002,0x400a,	//battery
	0x401a,0x703a,0x1ffe,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x2040,0x4460,0x4970,0x937a,	//volume
	0x937a,0x4970,0x4460,0x2040,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x03c0,0x0420,0x0870,0x0830,	//headphone
	0x0810,0x0500,0x0380,0x01c0,0x0000,0x0000,0x0000,0x0000
};
uchar	segpos[]={
	40,140,160,180,190,205,-1,-1,-1,-1,-1,0,20,65,90,115,
	102,35,22,13,8,0,-1,-1,-1,-1,-1,127,116,84,65,48
};

#endif	_BEWITCH_H_
