/* (c) Beer/Won-wan    2003.5.3 */
#include	"libwitch.h"

int bw_start()
{
	bw_area_id=find_area("bewitch");
	if(bw_area_id<=0){printf("error : find_area\n");return(1);}
//else printf("ok : area_id=%d\n",bw_area_id);

	bw_area_id=clone_area("bewitch_c",(void**)&bw_area_adr,B_ANY_ADDRESS,B_READ_AREA|B_WRITE_AREA,bw_area_id);
	if(bw_area_id<=0){printf("error : clone_area\n");return(2);}
//else printf("ok : area_id=%d\n",bw_area_id);

//printf("area_adr=%08lx  area_size=%04x\n",bw_area_adr,bw_area_size);
	if(bw_init()){printf("error : init_font\n");return(-1);}
//else printf("swanfont ok\n",bw_area_id);
	return(0);
}

int bw_init()
{
	int		i,r;
	FILE	*fp;
	uchar	hard=*(bw_area_adr+bw_hard_adr);
	r=0;
	for(i=0;i<bw_area_size;i++)*(bw_area_adr+i)=0;
	fp=fopen("/boot/home/bewitch/font/swanfont","rb");
	if(fp)fread(bw_area_adr+bw_font_adr,8,0x8000,fp);
	else r=-1;

	*(bw_area_adr+bw_hard_adr)=hard;

	*(bw_area_adr+bw_lcd_adr)=0x01;
	*(short*)(bw_area_adr+bw_disp_adr)=0x0003;
	*(bw_area_adr+bw_scr2_win_adr)=0x00;
	*(bw_area_adr+bw_scr2_win_adr+1)=0x00;
	*(bw_area_adr+bw_scr2_win_adr+2)=0xff;
	*(bw_area_adr+bw_scr2_win_adr+3)=0xff;
	*(bw_area_adr+bw_spr_win_adr)=0x00;
	*(bw_area_adr+bw_spr_win_adr+1)=0x00;
	*(bw_area_adr+bw_spr_win_adr+2)=0xff;
	*(bw_area_adr+bw_spr_win_adr+3)=0xff;
	*(bw_area_adr+bw_cur_adr)=0x00;
	*(short*)(bw_area_adr+bw_cur_type_adr)=0x1e01;
	*(bw_area_adr+bw_cur_loc_adr)=0x00;
	*(bw_area_adr+bw_cur_loc_adr+1)=0x00;
	*(bw_area_adr+bw_cur_loc_adr+2)=0x01;
	*(bw_area_adr+bw_cur_loc_adr+3)=0x01;
	*(short*)(bw_area_adr+bw_chr_pal_adr)=0x7530;
	*(short*)(bw_area_adr+bw_chr_pal_adr+2)=0x7532;
	*(short*)(bw_area_adr+bw_chr_pal_adr+4)=0x7000;
	*(short*)(bw_area_adr+bw_chr_pal_adr+6)=0x7002;
	*(short*)(bw_area_adr+bw_chr_pal_adr+8)=0x7300;
	*(short*)(bw_area_adr+bw_chr_pal_adr+10)=0x1000;
	*(short*)(bw_area_adr+bw_chr_pal_adr+12)=0x0000;
	*(short*)(bw_area_adr+bw_chr_pal_adr+14)=0x2000;
	*(short*)(bw_area_adr+bw_chr_pal_adr+16)=0x7530;
	*(short*)(bw_area_adr+bw_chr_pal_adr+18)=0x6041;
	*(short*)(bw_area_adr+bw_chr_pal_adr+20)=0x0650;
	*(short*)(bw_area_adr+bw_chr_pal_adr+22)=0x6460;
	*(short*)(bw_area_adr+bw_chr_pal_adr+24)=0x7400;
	*(short*)(bw_area_adr+bw_chr_pal_adr+26)=0x7000;
	*(short*)(bw_area_adr+bw_chr_pal_adr+28)=0x0020;
	*(short*)(bw_area_adr+bw_chr_pal_adr+30)=0x0010;
	*(bw_area_adr+bw_col_mode_adr)=0x0;
	*(bw_area_adr+bw_lcd_pal_adr)=0x0;
	*(bw_area_adr+bw_lcd_pal_adr+1)=0x2;
	*(bw_area_adr+bw_lcd_pal_adr+2)=0x4;
	*(bw_area_adr+bw_lcd_pal_adr+3)=0x6;
	*(bw_area_adr+bw_lcd_pal_adr+4)=0x8;
	*(bw_area_adr+bw_lcd_pal_adr+5)=0xa;
	*(bw_area_adr+bw_lcd_pal_adr+6)=0xc;
	*(bw_area_adr+bw_lcd_pal_adr+7)=0xf;

	*(bw_area_adr+bw_text_scr_adr)=0x1;
	*(bw_area_adr+bw_text_mode_adr)=0x1;
	*(bw_area_adr+bw_text_pal_adr)=0x0;
	*(bw_area_adr+bw_font_col_adr)=0x0;
	*(bw_area_adr+bw_font_col_adr+1)=0x3;
	
	*(bw_area_adr+bw_flag_init_adr)=0x00;	//init ok
	return(r);
}

int	bw_quit()
{
	*(bw_area_adr+bw_flag_init_adr)=0xff;	//quit(not-init)
}

int	bw_ver()
{
	return(*(bw_area_adr+bw_ver_adr));
}

int bw_test()
{
	return(0);
}

/* wonderwitch function */
//---------------------------------------------------------------------- comm
void comm_open(void)
{
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	*p=1;
	while(*p)snooze(10000);		/* wait 0.01sec */
}
void comm_close(void)
{
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	*p=2;
	while(*p)snooze(10000);		/* wait 0.01sec */
}
short comm_send_char(uchar byte)
{
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	*(ushort*)(bw_area_adr+bw_com_len_adr)=1;
	*(bw_area_adr+bw_com_buf_adr)=byte;
	*p=4;
	while(*p)snooze(10000);		/* wait 0.01sec */
	return(*(short*)(bw_area_adr+bw_com_stt_adr));
}
short comm_receive_char(void)
{
	short	r;
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	*(ushort*)(bw_area_adr+bw_com_len_adr)=1;
	*p=8;
	while(*p)snooze(10000);		/* wait 0.01sec */
	r=*(short*)(bw_area_adr+bw_com_stt_adr);
	if(r==0)r=*(bw_area_adr+bw_com_buf_adr);
	return(r);
}
short comm_receive_with_timeout(short timeout)
{
	short	r,t;
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	t=*(short*)(bw_area_adr+bw_com_tout_adr);
	*(short*)(bw_area_adr+bw_com_tout_adr)=timeout;
	*(ushort*)(bw_area_adr+bw_com_len_adr)=1;
	*p=8;
	while(*p)snooze(10000);		/* wait 0.01sec */
	*(short*)(bw_area_adr+bw_com_tout_adr)=t;
	r=*(short*)(bw_area_adr+bw_com_stt_adr);
	if(r==0)r=*(bw_area_adr+bw_com_buf_adr);
	return(r);
}
short comm_send_string(char *string)
{
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	*(ushort*)(bw_area_adr+bw_com_len_adr)=strlen(string);
	strcpy(bw_area_adr+bw_com_buf_adr,string);
	*p=4;
	while(*p)snooze(10000);		/* wait 0.01sec */
	return(*(short*)(bw_area_adr+bw_com_stt_adr));
}
short comm_send_block(void *buffer,short size)
{
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	*(ushort*)(bw_area_adr+bw_com_len_adr)=size;
	memcpy(bw_area_adr+bw_com_buf_adr,buffer,size);
	*p=4;
	while(*p)snooze(10000);		/* wait 0.01sec */
	return(*(short*)(bw_area_adr+bw_com_stt_adr));
}
short comm_receive_block(void *buffer,short size,short *bytes)
{
	uchar	*p=bw_area_adr+bw_com_cmd_adr;
	*(ushort*)(bw_area_adr+bw_com_len_adr)=size;
	*p=8;
	while(*p)snooze(10000);		/* wait 0.01sec */
	*bytes=*(short*)(bw_area_adr+bw_com_len_adr);
	memcpy(buffer,bw_area_adr+bw_com_buf_adr,*bytes);
	return(*(short*)(bw_area_adr+bw_com_stt_adr));
}
void comm_set_timeout(short receive_timeout,short send_timeout)
{
	short	*p=(short*)(bw_area_adr+bw_com_tout_adr);
	*(p++)=receive_timeout;
	*p=send_timeout;
}
void comm_set_baudrate(short speed)
{
	*(bw_area_adr+bw_com_bps_adr)=speed;
}
short comm_get_baudrate(void)
{
	return(*(bw_area_adr+bw_com_bps_adr));
}
void comm_set_cancel_key(ushort cancel_key_pattern)
{
	*(ushort*)(bw_area_adr+bw_com_ckey_adr)=cancel_key_pattern;
}
ushort comm_get_cancel_key(void)
{
	return(*(ushort*)(bw_area_adr+bw_com_ckey_adr));
}
short comm_xmodem(xmodeminfo *xmodem)
{
	return(0);
}
//---------------------------------------------------------------------- disp
void lcd_set_interrupt_line(uchar line)
{
}
uchar lcd_get_display_line()
{
	return(0);
}
void display_control(ushort flags)
{
	*(ushort*)(bw_area_adr+bw_disp_adr)=flags;
}
ushort display_status()
{
	return(*(ushort*)(bw_area_adr+bw_disp_adr));
}
void font_set_monodata(ushort char_no,ushort char_count,void *data_p)
{
	int	i;
	char	bc=*(bw_area_adr+bw_font_col_adr);
	char	fc=*(bw_area_adr+bw_font_col_adr+1);
	char	*p=(char*)data_p;
	char	*q=bw_area_adr+bw_chr_adr+char_no*16;
	for(i=0;i<char_count*8;i++){
		*q=0;
		if(fc&1)*q|=*p;
		if(bc&1)*q|=~*p;
		q++;
		*q=0;
		if(fc&2)*q|=*p;
		if(bc&2)*q|=~*p;
		q++;
		p++;
	}
}
void font_set_colordata(ushort char_no,ushort char_count,void *data_p)
{
	int	i;
	char	*p=(char*)data_p;
	char	*q=bw_area_adr+bw_chr_adr+char_no*16;
	for(i=0;i<char_count*16;i++)*(q++)=*(p++);
}
void font_get_data(ushort char_no,ushort char_count,void *data_p)
{
	int	i;
	char	*q=(char*)data_p;
	char	*p=bw_area_adr+bw_chr_adr+char_no*16;
	for(i=0;i<char_count*16;i++)*(q++)=*(p++);
}
void font_set_color(ushort colors)
{
	*(bw_area_adr+bw_font_col_adr)=(colors&0x0c)>>2;	/*bc*/
	*(bw_area_adr+bw_font_col_adr+1)=colors&0x03;		/*fc*/
}
ushort font_get_color()
{
	return((*(bw_area_adr+bw_font_col_adr)<<2)|*(bw_area_adr+bw_font_col_adr+1));
}
void screen_set_char(short screen,short x,short y,short w,short h,void *data_p)
{
	int		ix,iy;
	ushort	*p=(ushort*)data_p;
	ushort	*q=(ushort*)(screen==0?bw_area_adr+bw_scr1_adr:bw_area_adr+bw_scr2_adr);
	q+=y*32+x;
	for(iy=0;iy<h;iy++)for(ix=0;ix<w;ix++)*(q+iy*32+ix)=*(p++);
}
void screen_get_char(short screen,short x,short y,short w,short h,void *data_p)
{
	int		ix,iy;
	ushort	*q=(ushort*)data_p;
	ushort	*p=(ushort*)(screen==0?bw_area_adr+bw_scr1_adr:bw_area_adr+bw_scr2_adr);
	p+=y*32+x;
	for(iy=0;iy<h;iy++)for(ix=0;ix<w;ix++)*(q++)=*(p+iy*32+ix);
}
ushort screen_get_char1(short screen,short x,short y)
{
	ushort	*p=(ushort*)(screen==0?bw_area_adr+bw_scr1_adr:bw_area_adr+bw_scr2_adr);
	return(*(p+y*32+x));
}
void screen_fill_char(short screen,short x,short y,short w,short h,ushort data)
{
	int		ix,iy;
	ushort	*p=(ushort*)(screen==0?bw_area_adr+bw_scr1_adr:bw_area_adr+bw_scr2_adr);
	p+=y*32+x;
	for(iy=0;iy<h;iy++)for(ix=0;ix<w;ix++)*(p+iy*32+ix)=data;
}
void screen_fill_attr(short screen,short x,short y,short w,short h,ushort data,ushort mask)
{
	int		ix,iy;
	ushort	*p=(ushort*)(screen==0?bw_area_adr+bw_scr1_adr:bw_area_adr+bw_scr2_adr);
	p+=y*32+x;
	for(iy=0;iy<h;iy++)for(ix=0;ix<w;ix++){*(p+iy*32+ix)&=mask;*(p+iy*32+ix)|=data;}
}
void sprite_set_range(ushort sprite_start,ushort sprite_count)
{
	*(bw_area_adr+bw_spr_rg_adr)=sprite_start;
	*(bw_area_adr+bw_spr_rg_adr+1)=sprite_count;
}
void sprite_set_char(ushort sprite_no,ushort char_data)
{
	*(ushort*)(bw_area_adr+bw_spr_adr+sprite_no*4)=char_data;
}
ushort sprite_get_char(ushort sprite_no)
{
	return(*(ushort*)(bw_area_adr+bw_spr_adr+sprite_no*4));
}
void sprite_set_location(ushort sprite_no,short x,short y)
{
	uchar	*p=bw_area_adr+bw_spr_adr+sprite_no*4+2;
	*(p++)=(uchar)x;
	*p=(uchar)y;
}
ushort sprite_get_location(ushort sprite_no)
{
	return(*(ushort*)(bw_area_adr+bw_spr_adr+sprite_no*4+2));
}
void sprite_set_char_location(ushort sprite_no,ushort char_data,short x,short y)
{
	uchar	*p=bw_area_adr+bw_spr_adr+sprite_no*4;
	*(ushort*)p=char_data;
	*(p+2)=(uchar)x;
	*(p+3)=(uchar)y;
}
ulong sprite_get_char_location(ushort sprite_no)
{
	return(*(ulong*)(bw_area_adr+bw_spr_adr+sprite_no*4));
}
void sprite_set_data(ushort sprite_no,ushort sprite_count,void *data_p)
{
	int		i;
	uchar	*p,*q;
	p=(uchar*)data_p;
	q=bw_area_adr+bw_spr_adr+sprite_no*4;
	for(i=0;i<sprite_count;i++){
		*q=*p;	*(q+1)=*(p+1);	*(q+2)=*(p+3);	*(q+3)=*(p+2);
		p+=4;q+=4;
	}
}
void screen_set_scroll(short screen,short x,short y)
{
	uchar	*p=bw_area_adr+bw_scr_scrl_adr+screen*2;
	*(p++)=x;
	*p=y;
}
ushort screen_get_scroll(short screen)
{
	return(*(ushort*)(bw_area_adr+bw_scr_scrl_adr+screen*2));
}
void screen2_set_window(short x,short y,short w,short h)
{
	uchar	*p=bw_area_adr+bw_scr2_win_adr;
	*(p++)=x;
	*(p++)=y;
	*(p++)=w;
	*p=h;
}
ulong screen2_get_window()
{
	return(*(ulong*)(bw_area_adr+bw_scr2_win_adr));
}
void sprite_set_window(short x,short y,short w,short h)
{
	uchar	*p=bw_area_adr+bw_spr_win_adr;
	*(p++)=x;
	*(p++)=y;
	*(p++)=w;
	*p=h;
}
ulong sprite_get_window()
{
	return(*(ulong*)(bw_area_adr+bw_spr_win_adr));
}
void palette_set_color(ushort palette_no,ushort colors)
{
	*(ushort*)(bw_area_adr+bw_chr_pal_adr+palette_no*2)=colors;
}
ushort palette_get_color(ushort palette_no)
{
	return(*(ushort*)(bw_area_adr+bw_chr_pal_adr+palette_no*2));
}
void lcd_set_color(ushort colors0,ushort colors1)
{
	int		i;
	uchar	*p=bw_area_adr+bw_lcd_pal_adr;
	for(i=0;i<4;i++){*(p++)=colors0&0x0f;colors0>>=4;}
	for(i=0;i<4;i++){*(p++)=colors1&0x0f;colors1>>=4;}
}
ulong lcd_get_color()
{
	int		i;
	ulong	l=0;
	uchar	*p=bw_area_adr+bw_lcd_pal_adr;
	for(i=0;i<8;i++){l|=*(p++);l<<=4;}
	return(l);
}
void lcd_set_segments(ushort segments)
{
	*(ushort*)(bw_area_adr+bw_seg_adr)=segments;
}
ushort lcd_get_segments()
{
	return(*(ushort*)(bw_area_adr+bw_seg_adr));
}
void lcd_set_sleep(ushort sleep)
{
	*(bw_area_adr+bw_lcd_adr)=sleep;
}
ushort lcd_get_sleep()
{
	return(*(bw_area_adr+bw_lcd_adr));
}
void screen_set_vram(short screen,short locationID)
{
}
void sprite_set_vram(short locationID)
{
}
//---------------------------------------------------------------------- key
short key_press_check()
{
	*(short*)(bw_area_adr+bw_key_hit_adr)=0;
	*(short*)(bw_area_adr+bw_key_hitr_adr)=0;
	return(*(short*)(bw_area_adr+bw_key_adr));
}
short key_hit_check()
{
	short	k;
	k=*(short*)(bw_area_adr+bw_key_hit_adr);
	*(short*)(bw_area_adr+bw_key_hit_adr)=0;
	*(short*)(bw_area_adr+bw_key_hitr_adr)=0;
	return(k);
}
short key_wait()
{
	short	k;
	while(!(k=*(short*)(bw_area_adr+bw_key_hitr_adr)))snooze(10000);		/* wait 0.01sec */
	*(short*)(bw_area_adr+bw_key_hit_adr)=0;
	*(short*)(bw_area_adr+bw_key_hitr_adr)=0;
	return(k);
}
void key_set_repeat(short rate,short delay)
{
	uchar	*p=bw_area_adr+bw_key_rep_adr;
	*(p++)=rate;
	*p=delay;
}
short key_get_repeat()
{
	return(*(short*)(bw_area_adr+bw_key_rep_adr));
}
short key_hit_check_with_repeat()
{
	short	k;
	k=*(short*)(bw_area_adr+bw_key_hitr_adr);
	*(short*)(bw_area_adr+bw_key_hit_adr)=0;
	*(short*)(bw_area_adr+bw_key_hitr_adr)=0;
	return(k);
}
//----------------------------------------------------------------------libwwc
ushort wwc_set_color_mode(ushort mode)
{
	*(bw_area_adr+bw_col_mode_adr)=(uchar)mode;
	return(mode);
}
ushort wwc_get_color_mode(void)
{
	return((ushort)*(bw_area_adr+bw_col_mode_adr));
}
void wwc_palette_set_color(ushort palette_no,ushort index,ushort rgb)
{
	*(ushort*)(bw_area_adr+bw_col_pal_adr+palette_no*32+index*2)=rgb;
}
ushort wwc_palette_get_color(ushort palette_no,ushort index)
{
	return(*(ushort*)(bw_area_adr+bw_col_pal_adr+palette_no*32+index*2));
}
void wwc_font_set_colordata(ushort char_no,ushort char_count,void *data_p)
{
	int	i;
	uchar	*p=(char*)data_p;
	uchar	*q=bw_area_adr+bw_col_chr_adr+char_no*32;
	for(i=0;i<char_count*32;i++)*(q++)=*(p++);
}
void wwc_font_get_colordata(ushort char_no,ushort char_count,void *buf_p)
{
	int	i;
	uchar	*q=(char*)buf_p;
	uchar	*p=bw_area_adr+bw_col_chr_adr+char_no*32;
	for(i=0;i<char_count*32;i++)*(q++)=*(p++);
}
ushort wwc_get_hardarch(void)
{
	return((ushort)*(bw_area_adr+bw_hard_adr));
}
void wwc_clear_font(void)
{
	int	i;
	char	*q=bw_area_adr+bw_col_chr_adr;
	for(i=0;i<1024*32;i++)*(q++)=0;
}
short wwc_sys_get_ownerinfo(short count,char *buffer)
{
	return(0);
}
//----------------------------------------------------------------------sound
void sound_set_voice_volume(ushort left,ushort right)
{
	*(bw_area_adr+bw_snd_voice_adr)=(((left&0x03)<<2)|(right&0x03));
}
ushort sound_get_voice_volume()
{
	return((ushort)(*(bw_area_adr+bw_snd_voice_adr)));
}
void sound_init()
{
	int	i;
	uchar	*p=bw_area_adr+bw_snd_wave_adr;
	for(i=0;i<64;i++)*(p++)=0;
	*(bw_area_adr+bw_snd_ch_adr)=0;
	*(bw_area_adr+bw_flag_sound_adr)|=0x0f;		//all-ch. update
//printf("sound_init\n");
}
void sound_set_channel(ushort sound_flags)
{
	*(bw_area_adr+bw_snd_ch_adr)=sound_flags;
	*(bw_area_adr+bw_flag_sound_adr)|=0x0f;		//all-ch. update
//printf("sound_set_ch\n");
}
ushort sound_get_channel()
{
	return(*(bw_area_adr+bw_snd_ch_adr));
}
void sound_set_output(ushort output_flags)
{
	*(bw_area_adr+bw_snd_out_adr)=output_flags;
}
ushort sound_get_output()
{
	return(*(bw_area_adr+bw_snd_out_adr));
}
void sound_set_wave(short channel,uchar *wave_p)
{
	int	i;
	uchar	*p,*q;
	p=wave_p;
	q=bw_area_adr+bw_snd_wave_adr+channel*16;
	for(i=0;i<16;i++)*(q++)=*(p++);
	*(bw_area_adr+bw_flag_sound_adr)|=0x01<<channel;	//ch. update
//printf("sound_set_wave\n");
}
void sound_set_pitch(short channel,ushort freq)
{
	*(ushort*)(bw_area_adr+bw_snd_pitch_adr+channel*2)=freq;
	*(bw_area_adr+bw_flag_sound_adr)|=0x01<<channel;	//ch. update
//printf("sound_set_pitch\n");
}
ushort sound_get_pitch(short channel)
{
	return(*(ushort*)(bw_area_adr+bw_snd_pitch_adr+channel*2));
}
void sound_set_volume(short channel,ushort volume)
{
	*(bw_area_adr+bw_snd_vol_adr+channel)=volume;
	*(bw_area_adr+bw_flag_sound_adr)|=0x01<<channel;	//ch. update
//printf("sound_set_vol\n");
}
ushort sound_get_volume(short channel)
{
	return(*(bw_area_adr+bw_snd_vol_adr+channel));
}
void sound_set_sweep(short sweep,short steptime)
{
	uchar	*p=bw_area_adr+bw_snd_sweep_adr;
	*(p++)=sweep;
	*p=steptime;
	*(bw_area_adr+bw_flag_sound_adr)|=0x04;				//ch.3 update
//printf("sound_set_sweep\n");
}
ushort sound_get_sweep()
{
	return(*(ushort*)(bw_area_adr+bw_snd_sweep_adr));
}
void sound_set_noise(ushort noise_flags)
{
	*(bw_area_adr+bw_snd_noise_adr)=noise_flags;
	*(bw_area_adr+bw_flag_sound_adr)|=0x08;				//ch.4 update
//printf("sound_set_noise\n");
}
ushort sound_get_noise()
{
	return(*(bw_area_adr+bw_snd_noise_adr));
}
ushort sound_get_random()
{
	return(0);
}
//----------------------------------------------------------------------system
void sys_interrupt_set_hook(short type,intvector_t *intvector,intvector_t *last_intvector)
{
}
void sys_interrupt_reset_hook(short type,intvector_t *last_intvector)
{
}
void sys_wait(ushort time)
{
	if(time<=0)time=1;
	snooze(time*13333);		/* 1/75sec */
}
ulong sys_get_tick_count(void)
{
	return(*(ulong*)(bw_area_adr+bw_tick_adr));
}
void sys_sleep(void)
{
}
void sys_set_sleep_time(short sleep_time)
{
}
short sys_get_sleep_time(void)
{
	return(0);
}
void sys_set_awake_key(short awake_key_pattern)
{
}
short sys_get_awake_key(void)
{
	return(0);
}
void sys_set_keepalive_int(short keepalive_pattern)
{
}
short sys_get_ownerinfo(short size,char *buffer)
{
	return(0);
}
short sys_suspend(short core)
{
	return(0);
}
void sys_resume(short core)
{
}
void sys_set_remote(short remote_enable)
{
}
ushort sys_get_remote(void)
{
	return(0);
}
void* sys_alloc_iram(void *pointer,ushort size)
{
	return(NULL);
}
void sys_free_iram(void *pointer)
{
}
void* sys_get_my_iram(void)
{
	return(NULL);
}
ushort sys_get_version(void)
{
	return(0);
}
short sys_swap(short core)
{
	return(0);
}
void sys_set_resume(ushort flags)
{
}
ushort sys_get_resume()
{
	return(0);
}
//---------------------------------------------------------------------- text
void text_reset_ank_font()
{
}
void text_screen_init()
{
	ushort	*p=(ushort*)(bw_area_adr+bw_text_base_adr);
	if(*(bw_area_adr+bw_text_mode_adr)){	//SJIS mode
		*p=8;
		text_window_init(0,0,28,18,8);			//chr(8-511)
	}else{									//ANK mode
		*p=384;
		text_window_init(0,0,28,18,384);		//chr(384-511)
	}
}
void text_window_init(short x,short y,short w,short h,ushort font_base)
{
	int		i,j;
	uint	c,pl;
	ushort	*p;
	uchar	*q,*r;
	char	bc,fc;
	*(bw_area_adr+bw_text_win_adr)=x;
	*(bw_area_adr+bw_text_win_adr+1)=y;
	*(bw_area_adr+bw_text_win_adr+2)=w;
	*(bw_area_adr+bw_text_win_adr+3)=h;
	*(ushort*)(bw_area_adr+bw_text_base_adr)=font_base;
	p=(ushort*)(bw_area_adr+((*(bw_area_adr+bw_text_scr_adr)==0)?bw_scr1_adr:bw_scr2_adr));
	p+=y*32+x;
	q=bw_area_adr+bw_chr_adr+font_base*16;
	bc=*(bw_area_adr+bw_font_col_adr);
	fc=*(bw_area_adr+bw_font_col_adr+1);
	if(*(bw_area_adr+bw_text_mode_adr)){	//SJIS mode
		//chr(base-) <-> screen
		pl=*(bw_area_adr+bw_text_pal_adr);
		c=font_base;
		for(y=0;y<h;y++)for(x=0;x<w;x++)*(p+y*32+x)=(c++)|(pl<<9);
		//chrdata cls
		for(y=0;y<h;y++)for(x=0;x<w;x++)for(i=0;i<8;i++){
			*(q++)=(bc&1)?0xff:0x00;
			*(q++)=(bc&2)?0xff:0x00;
		}
	}else{									//ANK mode
		//font(0-127) -> chr(base-)
		r=bw_area_adr+bw_font_adr;
		for(c=0;c<128;c++){
			for(j=0;j<8;j++){
				*q=0;
				if(fc&1)*q|=*r;
				if(bc&1)*q|=~*r;
				q++;
				*q=0;
				if(fc&2)*q|=*r;
				if(bc&2)*q|=~*r;
				q++;
				r++;
			}
		}
		//screen cls
		for(y=0;y<h;y++)for(x=0;x<w;x++)*(p+y*32+x)=font_base;
	}
}
void text_set_mode(short mode)
{
	*(bw_area_adr+bw_text_mode_adr)=mode;
}
short text_get_mode()
{
	return(*(bw_area_adr+bw_text_mode_adr));
}
void text_put_char(short x,short y,ushort ch)
{
	int		i;
	ushort	*p;
	uchar	*q,*r;
	char	fc,bc;
	uint	c,pl;
	uchar	wx,wy,ww,wh;
	wx=*(bw_area_adr+bw_text_win_adr);
	wy=*(bw_area_adr+bw_text_win_adr+1);
	ww=*(bw_area_adr+bw_text_win_adr+2);
	wh=*(bw_area_adr+bw_text_win_adr+3);
	if((x>=ww)||(y>=wh))return;
	p=(ushort*)(bw_area_adr+(*(bw_area_adr+bw_text_scr_adr)?bw_scr2_adr:bw_scr1_adr));
	p+=(wy+y)*32+(wx+x);
	c=*(ushort*)(bw_area_adr+bw_text_base_adr);
	pl=*(bw_area_adr+bw_text_pal_adr)<<9;
	if(*(bw_area_adr+bw_text_mode_adr)){	//SJIS mode
		bc=*(bw_area_adr+bw_font_col_adr);
		fc=*(bw_area_adr+bw_font_col_adr+1);
		c+=y*ww+x;			//chr no
		q=bw_area_adr+bw_chr_adr+c*16;
		ch&=0x7fff;
		r=bw_area_adr+bw_font_adr+ch*8;
		for(i=0;i<8;i++){
			*q=0;
			if(fc&1)*q|=*r;
			if(bc&1)*q|=~*r;
			q++;
			*q=0;
			if(fc&2)*q|=*r;
			if(bc&2)*q|=~*r;
			q++;
			r++;
		}
		*p=*p&0xe1ff|pl;
	}else{									//ANK mode
		ch&=0x7f;
		*p=(c+ch)|pl;
	}
}
short text_put_string(short x,short y,char *str)
{
	ushort	c;
	short	l=0;
	uchar	ww,wh;
	ww=*(bw_area_adr+bw_text_win_adr+2);
	wh=*(bw_area_adr+bw_text_win_adr+3);
	if((x>=ww)||(y>=wh))return(0);
	while(*str){
		if(*str&0x8000){c=(ushort)(*(uchar*)(str++))<<8;c|=(ushort)(*(uchar*)(str++));}
		else{c=(ushort)(*(str++));}
		text_put_char(x,y,c);
		l++;
		x++;if(x>=ww){x=0;y++;if(y>=wh)break;}
	}
	return(l);
}
short text_put_substring(short x,short y,char *str,short len)
{
	ushort	c;
	short	l=0;
	uchar	ww,wh;
	ww=*(bw_area_adr+bw_text_win_adr+2);
	wh=*(bw_area_adr+bw_text_win_adr+3);
	if((x>=ww)||(y>=wh))return(0);
	while((l<len)&&(*str)){
		if(*str&0x8000){c=(ushort)(*(uchar*)(str++))<<8;c|=(ushort)(*(uchar*)(str++));}
		else{c=(ushort)(*(str++));}
		text_put_char(x,y,c);
		l++;
		x++;if(x>=ww){x=0;y++;if(y>=wh)break;}
	}
	return(l);
}
void text_put_numeric(short x,short y,short len,short format,short number)
{
	char	s[16];
	text_store_numeric(s,len,format,number);
	text_put_string(x,y,s);
}
void text_store_numeric(char *buffer,short len,short format,short number)
{
	char	f[10];
	strcpy(f,"%");
	if(format&0x08)strcat(f,"+");
	if(format&0x04)strcat(f,"-");
	if(format&0x02)strcat(f,"0");
	sprintf(f,"%s%d",f,len);
	if(format&0x01)strcat(f,"x");else strcat(f,"d");
	sprintf(buffer,f,number);
}
void text_fill_char(short x,short y,short len,short char_code)
{
	uchar	ww,wh;
	ww=*(bw_area_adr+bw_text_win_adr+2);
	wh=*(bw_area_adr+bw_text_win_adr+3);
	if((x>=ww)||(y>=wh))return;
	while(len--){
		text_put_char(x,y,char_code);
		x++;if(x>=ww){x=0;y++;if(y>=wh)break;}
	}
}
void text_set_palette(short palette_no)
{
	*(bw_area_adr+bw_text_pal_adr)=palette_no;
}
short text_get_palette()
{
	return(*(bw_area_adr+bw_text_pal_adr));
}
void text_set_ank_font(short font_base_no,short is_color,short font_count,void *font_p)
{
}
void text_set_sjis_font(void *font_address)
{
}
void text_get_fontdata(short char_code,void *fontdata_buffer)
{
	int		i;
	char	*p,*q;
	p=bw_area_adr+bw_font_adr+(char_code&0x7fff)*8;
	q=(char*)fontdata_buffer;
	for(i=0;i<8;i++)*(q++)=*(p++);
}
void text_set_screen(short screen)
{
	*(bw_area_adr+bw_text_scr_adr)=screen;
}
short text_get_screen()
{
	return(*(bw_area_adr+bw_text_scr_adr));
}
void cursor_display(short cursor_enable)
{
	*(bw_area_adr+bw_cur_adr)=cursor_enable;
}
short cursor_status()
{
	return(*(bw_area_adr+bw_cur_stt_adr));
}
void cursor_set_location(short x,short y,short w,short h)
{
	uchar	*p=bw_area_adr+bw_cur_loc_adr;
	*(p++)=x;
	*(p++)=y;
	*(p++)=w;
	*p=h;
}
ulong cursor_get_location()
{
	return(*(ulong*)(*(bw_area_adr+bw_cur_loc_adr)));
}
void cursor_set_type(short cursor_palette_no,short blink_interval)
{
	short	*p=(short*)(bw_area_adr+bw_cur_type_adr);
	*(p++)=cursor_palette_no;
	*p=blink_interval;
}
ulong cursor_get_type()
{
	return(*(ulong*)(*(bw_area_adr+bw_cur_type_adr)));
}
short text_printf(short x,short y,const char *format,...)
{
	return(0);
}
//---------------------------------------------------------------------- timer
void rtc_set_datetime(short field,ushort value)
{
}
ushort rtc_get_datetime(short field)
{
	ushort	r=0;
	struct tm	*lt;
	time_t		ct;
	ct=time(0);
	lt=localtime(&ct);
	if(field==RTC_YEAR)r=lt->tm_year-100;
	else if(field==RTC_MONTH)r=lt->tm_mon+1;
	else if(field==RTC_DATE)r=lt->tm_mday;
	else if(field==RTC_DAY_OF_WEEK)r=lt->tm_wday;
	else if(field==RTC_HOUR)r=lt->tm_hour;
	else if(field==RTC_MIN)r=lt->tm_min;
	else if(field==RTC_SEC)r=lt->tm_sec;
	return(r);
}
void rtc_set_datetime_struct(datetime_t *buf)
{
}
void rtc_get_datetime_struct(datetime_t *buf)
{
	uchar	*p=(uchar*)buf;
	struct tm	*lt;
	time_t		ct;
	ct=time(0);
	lt=localtime(&ct);
	*(p++)=lt->tm_year-100;
	*(p++)=lt->tm_mon+1;
	*(p++)=lt->tm_mday;
	*(p++)=lt->tm_wday;
	*(p++)=lt->tm_hour;
	*(p++)=lt->tm_min;
	*(p++)=lt->tm_sec;
}
void rtc_enable_alarm(short hour,short min)
{
}
void rtc_disable_alarm(void)
{
}
void timer_enable(short timer_type,ushort auto_preset,ushort preset)
{
}
void timer_disable(short timer_type)
{
}
ushort timer_get_count(short timer_type)
{
	return(0);
}
